package pvc

import (
	"github.com/ankitrgadiya/operatorlib/pkg/interfaces"
	"github.com/ankitrgadiya/operatorlib/pkg/meta"

	corev1 "k8s.io/api/core/v1"
)

// GenConfigMapFunc defines a function which generates ConfigMap.
type GenPVCFunc func(Conf) (*corev1.PersistentVolumeClaim, error)
type GenResourcesFunc func(interfaces.Object) (corev1.ResourceRequirements, error)
type GenAccessModesFunc func(interfaces.Object) ([]corev1.PersistentVolumeAccessMode, error)

// Conf is used to pass parameters to functions in this package to
// perform operations on Configmap objects.
type Conf struct {
	Meta meta.Conf
	//	Instance       interfaces.Object
	//	Namespace      string
	//	Name           string
	Reconcile interfaces.Reconcile
	//	OwnerReference bool
	//	operation.MaybeUpdateFunc
	//	operation.AfterCreateFunc
	//	operation.AfterUpdateFunc
	//	operation.AfterDeleteFunc
	GenPVCFunc
	StorageClassName *string
	GenResourcesFunc
	GenAccessModesFunc
	//	GenFinalizers
	//	GenLabels
	//	GenAnnotations
}
